//vim: syntax=c:tabstop=2:softtabstop=2:shiftwidth=2

#define BUTTON 12 // пин для подключения кнопки

#define REGS 4 // количество регистров экрана
char anods[REGS] = {8,9,10,11}; // пины анодов
char pins[] = {0,1,2,3,4,5,6}; // пины семисегментного индикатора
volatile char d[REGS] = {17,17,17,17}; // сюда пишем число для отображения
volatile char reg = 0; // тут сохраняем номер разряда, с которым будет работать обработчик прерывания
volatile char prev_reg = REGS - 1; // тут номер предыдущего обработанного разряда
bool button_state = false; // текущее состояние кнопки
char dig[] = {
	0b01000000,			// 0
	0b01111001,			// 1
	0b00100100,			// 2
	0b00110000,			// 3
	0b00011001,			// 4
	0b00010010,			// 5
	0b00000010,			// 6
	0b01111000,			// 7
	0b00000000,			// 8
	0b00010000,			// 9
	0b00001000,			// A
	0b00000011,			// b
	0b01000110,			// C
	0b00100001,			// d
	0b00000110,			// E
	0b00001110,			// F
	0b01111111,			// чисто - индекс 16
	0b00111111,			// -	-	индекс 17
	0b00011100,			// градус	-	индекс 18
};

ISR(TIMER2_OVF_vect) // вектор прерывания по переполнению
{
	digitalWrite(anods[prev_reg], LOW); // отрубаем аноды матрицы
	char i = 0; // счетчик битов
	for(char mask=0b00000001; i<8; mask<<=1) // цикл маски битов
	{
		digitalWrite(pins[i++], (dig[d[reg]] & mask) ? HIGH: LOW); // берем поочередно биты и включаем нужные
	}
	digitalWrite(anods[reg], HIGH); // как выставили все биты катодов, можно включить и анод текущего разряда
	prev_reg = reg; // сохраняем номер зажженного разряда
	reg++; // увеличиваем разряд, что бы в следующий раз его включать
	if(reg == REGS) // если это последний разряд...
		reg = 0; // ... начинаем с начального разряда
}

void setup()
{
	for(char i=0; i<sizeof(pins); i++) // выставим пины в out и погасим сегменты
	{
		pinMode(pins[i], OUTPUT);
		digitalWrite(pins[i], LOW);
	}

	pinMode(12, INPUT); // пин для кнопки поставим в in

	for(char i=0; i<sizeof(anods); i++) // отключим аноды
	{
		pinMode(anods[i], OUTPUT);
		digitalWrite(anods[i], LOW);
	}

	//настраиваем Timer2: делитель /256, WGM mode 0 - по переполнению
	TCCR2A = 0;
	TCCR2B = 1<<CS22 | 1<<CS21;

	//Timer2 включаем прерывание по переполнению
	TIMSK2 = 1<<TOIE2;

	//обнуляем таймер
	TCNT2 = 0;
}

void loop()
{
	delay(100); // чуток подождем :) дребезг кнопки для простоты не обрабатываем
	if(digitalRead(BUTTON) == HIGH && !button_state) // если нажата кнопка и флаг не выставлен (ранее не была нажата) прибавляем в младший разряд единицу
	{
		button_state = true; // флаг выставляем, что кнопка нажата
		d[0]++; // собственно увеличиваем разряд на единицу
		for(char i=0; i<REGS; i++) // далее проверяем переполнение разрядов
		{
			if(d[i] > 9)
			{
				d[i] = 0;
				d[i+1]++;
			}
		}
	}
	else if(digitalRead(BUTTON) == LOW && button_state) // если кнопку отпустили, но ранее она была нажата (флаг выставлен) то...
		button_state = false; // ...убираем флаг
}
